<?php
/**
 * Zeigt alle Einträge von der Tabelle whitelist der Datenbank an
 * 
 */
class Dos {

	/**
	 *
	 * @var beroConf Instance root db
	 */
	private 	$bc,
			$m_attr,
			$q_attr,
			$start_attr,
			$order_attr,
			$sort_attr;

	private		$post_attr,
			$post_checked = 0;

	private		$isRequestRejected = 0,
			$reasonRejected = array();

	private		$form_id = 'dossettingsform';

	function __construct($m, $get = array(), $post = array(), $session = array()) {
		// loading beroConf
		require_once('/usr/fallback/beroConf.php');
		$this->bc = new beroConf('root');

		// set main GET variable
		$this->m_attr = $m;

		// check GET variable
                $this->q_attr 	  = isset($get['q']) 	 ? Helper::sanitizeGet($get['q']	, 'q'	 ) : 0;
                $this->start_attr = isset($get['start']) ? Helper::sanitizeGet($get['start']	, 'start') : 0 ;
                $this->order_attr = isset($get['order']) ? Helper::sanitizeGet($get['order']	, 'order') : 0 ;
                $this->sort_attr  = isset($get['sort'])  ? Helper::sanitizeGet($get['sort']	, 'sort' ) : 0 ;

                // get error from modal or submit execution
                if (isset($get['error'])) {
			$this->isRequestRejected = true;
			$this->reasonRejected = array('request' => $get['request'], 'checkor' => $get['checkor'], 'key' => $get['key']);
                	unset($get['error'], $get['request'], $get['checkor'], $get['key']);
                }

		//Save changes
		if (isset($post['action']) && $post['action'] == 'save') {
			// clean post
			unset($post['action'], $post['a'], $post['submit']);

			// checking post			 
			$list_post = array('m' => 'm', 'blacklist_max_packets' => 'int>=0', 'blacklist_timeframe' => 'int>=0', 'blacklist_blockduration' => 'int>=0', 'allowlan' => 'bool'); 

			$this->post_checked = 1;
			$this->post_attr = Helper::sanitizePost($post, $list_post, $this->post_checked, $this->reasonRejected);

                        $this->isRequestRejected = !$this->post_checked;
		}
	}

	/**
	 * @return string HTML code
	 */
	private function _display_tab1($m, $ba)
	{
		$html_str = 	"\n\n". '<!--BEGIN TAB1 //-->' ."\n\n" .
				'<div id="tabs-1">' ."\n";

		ob_start();
		?>
		<form name='dossettings' id='<?php echo $this->form_id; ?>' class = "form-horizontal" action='' style="margin-top: 20px;" method='POST'>
			<input type=hidden name=m value='<? echo $m ?>'>
			<input type=hidden name=a value='save'>
			<div class='form-group'>
				<label for='blacklist_max_packets' class='col-sm-5 control-label'><? echo DOS_BLACKLIST_MAX_PACKETS ?></label>
				<div class='col-sm-4'>
					<input type='text' class='form-control' id='blacklist_max_packets' name='blacklist_max_packets' 
						   value='<? echo $ba->get("blacklist_max_packets") ?>'>
				</div>
			</div>	
			<div class='form-group'>
				<label for='blacklist_timeframe' class='col-sm-5 control-label'><? echo DOS_BLACKLIST_TIMEFRAME ?></label>
				<div class='col-sm-4'>
					<input type='text' class='form-control' id='blacklist_timeframe' name='blacklist_timeframe' 
						   value='<? echo $ba->get("blacklist_timeframe") ?>'>
				</div>
			</div>	
			<div class='form-group'>
				<label for='blacklist_blockduration' class='col-sm-5 control-label'><? echo DOS_BLACKLIST_BLOCKDURATION ?></label>
				<div class='col-sm-4'>
					<input type='text' class='form-control' id='blacklist_blockduration' name='blacklist_blockduration' 
						   value='<? echo $ba->get("blacklist_blockduration") ?>'>
				</div>
				
			</div>

			<div class='text-center'>
				<input type='hidden' name='action' value='save'>
				<input name='submit' class='btn btn-default'  type='submit' value='<? echo BUTTON_SAVE ?>' >
			</div>
		</form>
		<?php
		
		$html_str .= 	ob_get_clean() . "\n" .
				'</div>' ."\n";

		return $html_str;
	}

	/**
	 * @return string HTML code
	 */
	private function _display_tab2 ($m, $q, $ba, $url_opts, $next_add, $start, $span)
	{
		include "./includes/functions.php";
		//Das Objekt funktions wird erzeugt um später die Navigationsleiste zu erzeugen.
		$functions = new functions();

		$whitelist_table = $this->dynamic_table_whitelist();

		//Erzeugung der Navigationsleiste.
		$query = $ba->select('SELECT * FROM whitelist');
		$record_count = sqlite_num_rows($query);

		$html_str = 	"\n\n". '<!--BEGIN TAB2 //-->' ."\n\n" .
				'<div id="tabs-2">' ."\n";

		ob_start();
		?>
		<script>
			function del(table, option) {
				conf = confirm('<? echo DOS_DELETE_MESS1_DIS ?>? ');
				if (conf == false) {
					return false;
				} else {
					window.location = './misc/delete.php?m=<? echo $m ?>&id=' + option + '&table=' + table;
				}
			}
			function delblacklist(table, option) {
				conf = confirm('<? echo DOS_DELETE_MESS1_DIS ?>? ');
				if (conf == false) {
					return false;
				} else {
					window.location = './misc/delete.php?m=<? echo $m ?>&id=' + option + '&table=' + table;
				}
			}
			function clearblacklist() {
				conf = confirm('<? echo DOS_CLEAR_BLACKLIST_WARNING ?>? ');
				if (conf == false) {
					return false;
				} else {
					window.location = './misc/delete.php?m=<? echo $m ?>&table=blacklist';
				}
			}
		</script>
		
		
		<div class='modal fade bs-example-modal-lg' id='dos-popup' tabindex='-1' role='dialog' aria-labelledby='myModalLabel' aria-hidden='true'>
			<div class='modal-dialog modal-lg'>
				<div class='modal-content'>
					<div class='modal-header'>
						<button type='button' class='close' data-dismiss='modal' aria-label='Close'><span aria-hidden='true'>&times;</span></button>
						<h4 class='modal-title' id='myModalLabel'><? echo DOS_TITLE_DIS ?></h4>
					</div>
					<div class='modal-body'>
					</div>
				</div>
			</div>
		</div>
		<br>
		<div id='container'>
			<? echo $whitelist_table ?>
		</div>
		<br>
		<div class='text-center'>
			<a href='modules/Dos/dos_popup.php?start=<? echo $next_add ?>' role='button' data-remote='false' data-toggle='modal' data-target='#dos-popup' class='btn btn-default'>
				<? echo BUTTON_ADD ?>
			</a>
		</div>
		<script type="text/javascript"> 
			$('#dos-popup').on('show.bs.modal', function (e) {
				var link = $(e.relatedTarget);
				$('.modal-body').load(link.attr('href'));
			});
		</script>

		<div class='text-center'>
			<? echo $functions->displayNavigationBlock($m, $q, $url_opts, $start, $span, $record_count) ?>
		</div>
		<?php
		
		$html_str .= 	ob_get_clean() . "\n" .
				'</div>' ."\n";

		return $html_str;
	}

	/**
	 * @return string HTML code
	 */
	private function _display_tab3()
	{
		$blacklist_table = $this->dynamic_table_blacklist();

		$html_str = 	"\n\n". '<!--BEGIN TAB3 //-->' ."\n\n" .
				'<div id="tabs-3">' ."\n";

		ob_start();
		?>
		<div class='modal fade bs-example-modal-lg' id='dos-popup' tabindex='-1' role='dialog' aria-labelledby='myModalLabel' aria-hidden='true'>
			<div class='modal-dialog modal-lg'>
				<div class='modal-content'>
					<div class='modal-header'>
						<button type='button' class='close' data-dismiss='modal' aria-label='Close'><span aria-hidden='true'>&times;</span></button>
						<h4 class='modal-title' id='myModalLabel'><? echo DOS_TITLE_DIS ?></h4>
					</div>
					<div class='modal-body'>
					</div>
				</div>
			</div>
		</div>
		<br>
		<div id='container'>
			<? echo $blacklist_table ?>
		</div>
		<br>

		<script type="text/javascript">
			$('#dos-popup').on('show.bs.modal', function (e) {
				var link = $(e.relatedTarget);
				$('.modal-body').load(link.attr('href'));
			});
		</script>

		<div class="text-center">
			<button type='submit' class='btn btn-default' onclick='clearblacklist();'><? echo DOS_BLACKLIST_CLEAR_ALL ?></button>
		</div>
		<?php
		
		$html_str .= 	ob_get_clean() . "\n" .
				'</div>' ."\n";

		return $html_str;
	}

	/**
	 * @return string HTML code
	 */
	private function _display_tabs($m, $q, $ba, $url_opts, $next_add, $start, $span)
	{
                $html_str =     '<br/>' . "\n" . '<br/>' . "\n" .
                                '<script>' . "\n" .
                                "\t" . '$(function() {' . "\n" .
                                "\t\t" . '$( "#tabs" ).tabs({active:0})' . "\n" .
                                "\t" . '});' . "\n" . 
                                '</script>' . "\n" .
				"\n\n" . '<!-- BEGIN TABS //-->' . "\n\n" .
				'<div id="tabs" class="">' . "\n" .
				"\t".'<ul>' . "\n" .
				'<li><a href="#tabs-1">DoS Settings</a></li>' . "\n" .
				'<li><a href="#tabs-2">Whitelist</a></li>' . "\n" .
				'<li><a href="#tabs-3">Blacklist</a></li>' . "\n" .
				"\t".'</ul>' . "\n" .	

				$this -> _display_tab1($m, $ba) . "\n" .
				$this -> _display_tab2($m, $q, $ba, $url_opts, $next_add, $start, $span) . "\n" .
				$this -> _display_tab3() . "\n" .

				"\n\n" . '<!-- END TABS //-->' . "\n" .
				'</div>' . "\n\n";

		return $html_str;
	}

	/**
	 * Die einträge der whitelist Tabelle werden formatiert angezeigt
	 * 
	 * @return string HTML Inhalt
	 */

	function display() {
	
		// args
		$m = $this->m_attr;
		$q = $this->q_attr;
		$start = $this->start_attr;
		$order = $this->order_attr;
		$sort = $this->sort_attr;

		$ba = new beroAri();

		$span = 15;
		$query = $ba->select('SELECT * FROM whitelist');
		$record_count = sqlite_num_rows($query);
		$test = $record_count / $span;
		$test = (int) $test;
		if ($record_count == 0) {
			$next_add = 0;
		} else {
			$next_add = ($test * $span);
		}

		$start = $start == '' ? 0 : $start;
		$order = $order;
		$sort = $sort;

		$name = "DOS_TITLE_DIS";
		include('./includes/header.php');

		if ($this->post_checked) {
			$option = 1;
			if (isset($this->post_attr['blacklist_max_packets'])) {
				$ba->set("blacklist_max_packets", sqlite_escape_string($this->post_attr["blacklist_max_packets"]));
			}
			if (isset($this->post_attr['blacklist_timeframe'])) {
				$ba->set("blacklist_timeframe", sqlite_escape_string($this->post_attr["blacklist_timeframe"]));
			}
			if (isset($this->post_attr['blacklist_blockduration'])) {
				$ba->set("blacklist_blockduration", sqlite_escape_string($this->post_attr["blacklist_blockduration"]));
			}
			
			$ret .= Helper::activate($option, true, $this->m_attr, ACTIVATE);	
		} else if ($this->isRequestRejected) {
			$ret .= Helper::displayErrorMessage($this->reasonRejected['request'], $this->reasonRejected['checkor'], $this->reasonRejected['key']);
		}

		$url_opts = array();
		$url_opts['sort'] = $sort;
		$url_opts['order'] = $order;

		// javascript code to check data filled
		ob_start();
		?>
		<script type="text/javascript">
			$(document).ready(function () {
				$("#<?php echo $this->form_id; ?>").validate({
       					rules: {
						blacklist_blockduration: {
							digits: true,
						},
						blacklist_max_packets: {
							digits: true,
						},
						blacklist_timeframe: {
							digits: true,
						}
					}
				});
			});
		</script>
		<?php

		$ret .= "\n" . ob_get_clean() . $this -> _display_tabs($m, $q, $ba, $url_opts, $next_add, $start, $span);
		return $ret; 
	}

	/**
	 * Liefert den HTML Code für die Tabelle
	 * 
	 * @return string HTLM code für die Tabelle
	 */

	function dynamic_table_whitelist() {
		//ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		require_once("./includes/lang.php");
		$start = $this->start_attr;

		//Das Header der Tabelle sind die Spaltennamen von whitelist
		$columns = $ba->column_type('whitelist');
		$i = 0;
		$columnsToShow = array("address","netmask");
		$colName = array("address" => DOS_WHITELIST_ADDRESS, "netmask" => DOS_WHITELIST_NETMASK_PREFIX);
		foreach ($columns as $column => $type) {
			if (in_array($column, $columnsToShow))
				$cols .= "<th>" . $colName[$column] . "</th>";
		}

		/* Die Einträge werden von der Tabelle whitelist gelesen, formatiert und in einer
		  Tabelle geschrieben, zusätzlich werden 2 Knöpfe eingebaut: modify und delete */
		$page = (($start / 15) + 1);
		if (!$start)
			$start = 0;
		$id = 0;

		for ($j = 1; $j <= $page; $j++) {
			$query = $ba->select('SELECT * FROM whitelist ORDER BY id asc limit 15 offset ' . $start);
			$rows = '';
			while ($entry = $ba->fetch_array($query)) {
				$rows .= "<tr>";
				for ($i = 0; $i < (count($columnsToShow)); $i++) {
					$col_name = $columnsToShow[$i];
					$rows .= "<td>" . $entry[$col_name] . "</td>";
				}
				$id = $entry['id'];
				$rows .= "<td class='buttons'>
				<a href='modules/Dos/dos_popup.php?id=" . $id . "' data-remote='false' data-toggle='modal' data-target='#dos-popup' class='popup_download'>
					<img src='./includes/images/modify.png'>
				</a>&nbsp;
				<a class='popup_download' onclick=\"del('whitelist','" . $id . "');\">
            	    <img src='./includes/images/delete.png'>
				</a>
				</td></tr>";
			}
		}

		$table = "<table class='table table-striped table-bordered' id='table' style='max-width:600px; margin:auto;'>"
			. "<tr>" 
			. $cols 
			. "<th></th>"
			. "</tr>"
			. $rows 
			. "</table>";
		//Rückgabe: Erzeugte Tabelle mit den Einträgen der Tabelle whitelist der Datenbank
		return $table;
	}

	function dynamic_table_blacklist() {
		
		require_once("./includes/lang.php");
		require_once "./includes/isgwtelnet.php";
		$i = 0;
		
		$cols .= "<th>" . DOS_BLACKLIST_ID . "</th>";
		$cols .= "<th>" . DOS_BLACKLIST_TIME . "</th>";
		$cols .= "<th>" . DOS_BLACKLIST_IP . "</th>";
		
		$isgw = new isgwtelnet();
		$result = $isgw->isgw_login();
		$blacklistresult = $isgw->isgw_blacklist();
	
		$bl_rows = explode("\n", $blacklistresult);
		$i=0;

		foreach ($bl_rows as $value){
			$id = -1;
			if (strncmp ("id:", $value, 3) != 0) {
				continue;
			}
			
			$rows .= "<tr>";
			$rvals = explode(" ", $value);
			
			if (count($rvals) != 3) {
				continue;
			}
			
			
			foreach ($rvals as $rval){

				$xval = explode(":", $rval);
				$rows .= "<td>" . $xval[1] . "</td>";
				if ($id == -1) {
					$id = $xval[1];
				}
			}
			
			$rows .= "<td class='buttons'>

			<a class='popup_download' onclick=\"delblacklist('blacklist','" . $id . "');\">
			<img src='./includes/images/delete.png'>
			</a>
			</td></tr>";
			
		}

		$table = "<table class='table table-striped table-bordered' id='table' style='max-width:600px; margin:auto;'>"
			. "<tr>" 
			. $cols 
			. "<th></th>"
			. "</tr>"
			. $rows 
			. "</table>";
		//Rückgabe: Erzeugte Tabelle mit den Einträgen der Tabelle whitelist der Datenbank
		return $table;
	}
	
}
?>
